package com.offcn.api.tk.app3;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.util.HashMap;
import java.util.Map;

import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.TK;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;




/**
 * 
 * @Description:   16.真题试卷-获取试卷报告页接口
 * @author: wff    
 * @date: 2019年6月20日 上午11:34:42   
 * @version V1.0
 */
public class getNormalPaperReport extends TK implements API {
	public String parameter;//参数集合
	
	public String record_id;//record_sub_id
	public String orgin;//来源 0为来自练习册,1为来自正常做题试卷,2扫描二维码试卷做题,3为来自模考大赛做题试卷
	public String channel;//1题库 2nwn
	public String orgin_id;//试卷或者练习册id

	@Override
	public void initialize(HashMap<String, Object> data) {
		if (!isProduct && data.get("CleanDB").toString().contains("Y")) {
			cleanUser_FromDB();//清除注册用户根据user_id
		}
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
		record_id = MapUtil.getParameter(parameter, "record_id").trim();
		orgin = MapUtil.getParameter(parameter, "orgin").trim();
		channel = MapUtil.getParameter(parameter, "channel").trim();
		orgin_id = MapUtil.getParameter(parameter, "orgin_id").trim();
		
		if ((!record_id.equals("")) && record_id.equals("code")) {
			record_id = record_id_L;
			parameter = parameter.replace("\"record_id\":code", "\"record_id\":\""+ record_id + "\"");
		}
		if ((!orgin_id.equals("")) && orgin_id.equals("code")) {
			orgin_id = paper_id_L;
			parameter = parameter.replace("\"orgin_id\":code", "\"orgin_id\":\""+ orgin_id + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Map<String, String> headers=new HashMap<String, String>();
		headers.put("Authorization", tk_token);
		
		Map<String, String>  jsonAsMap=new HashMap<String, String>();
		parameter = MapUtil.getValue("parameter", data);
		String tikuString= MapUtil.getParameter(parameter, "appid").trim();
		tikuString = MapUtil.killQuotes(tikuString, "\"");
		
		jsonAsMap.put("record_id", record_id);
		jsonAsMap.put("orgin", orgin);
		jsonAsMap.put("channel", channel);
		jsonAsMap.put("orgin_id", orgin_id);
		jsonAsMap.put("appid", tikuString);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setHeaders(headers);
		myRequest.setRequest(Request);
		myRequest.setFormParameter(jsonAsMap);
		myRequest.setUrl(Url);
		
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = StringUtils.decodeUnicode(re.asString());

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			if("0".equals(code)){
				
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
